/* Win32 GUI app skeleton */

#include <windows.h>
#include "getsolution.h"
#include <ddraw.h>

#include "getsolution.h"
#include <stdio.h>
#include <stdlib.h>

int size;
int* used;
char* letters;
int to_newline=0;
int count=0;
int gi=0;
int* sameas;
int matches;
char *dictionary[2000000];
char **results;

int getSolution(char* string)
{
	int j=0;
	int len = strlen(string);
	matches=0;
	gi=0;
	count=0;
	to_newline=0;
	size=len;
	letters = (char *)malloc(len);
	used = (int*)malloc(4*len);
	sameas = (int*) malloc(len*4);
	
	while(j<len)
	{
		letters[j]=tolower(string[j]);
		j++;
	}
	j=0;
	
	while(j<len)
	{
		used[j]=0;
		j++;
	}	
	
	shrink_and_sort();
	*string = '\0';
	
	combinations(string,0);

	j=0;
	while(j<gi)
		free(dictionary[j++]);
	
	//free(string);
	free(used);
	free(letters);
	free(sameas);
	return matches;
}

int strsort(char* str, int len)
{
	int smal = 0;
	int index=0;
	while(index <(len-1))
	{
		int c ;
		char temp;
		smal=index;
		for(c=index;c<len;c++)
		{
			if(str[c]<=str[smal])
				smal = c;
		}
		temp = str[smal];
		str[smal] = str[index];
		str[index]=temp;
		index++;
	}		
	return 1;
}
void shrink_and_sort()
{
	char* input = (char*)malloc(35);
	char* shrunk = (char*)malloc(size);
	int x =0;
	int s_i=0;
	while(x<size)
	{
		int j;
		sameas[x]=-1;
		for(j=(x+1);j<size;j++)
		{
			if(letters[x]==letters[j])
			{
				sameas[x]=j;
				break;
			}
		}
		x++;
	}
	x=0;

		
	while(x<size)
	{
		int y=0;
		while(y<s_i)
		{
			if(shrunk[y]==letters[x])
			{
				y=-1;
				break;
			}
			y++;
		}
		if((s_i==0)||(y!=-1))
		{
			shrunk[s_i]=letters[x];
			s_i++;
		}
		x++;
	}
	shrunk[s_i]='\0';
	
	strsort(shrunk, s_i);
	x=0;
	while(x<s_i)
	{
		FILE* afile;
		char name[] = "*";
	
		name[0]=shrunk[x];
		afile = fopen(name, "r");
	
		while(EOF!=fscanf(afile,"%s",input))
		{

			dictionary[gi]=input;
			input= (char*)malloc(80);
			gi++;
		}
	
		x++;
		fclose(afile);
	}

	free(shrunk);

}


int	comp(char** a, char** b)
{
	return strcmp((*a),(*b));
}

void combinations(char* pre, int sofar)
{
	int i=0;
	int entered = 0;
	char* samedone;
	samedone =(char*) malloc(size);
	while(i<size)
	{
		samedone[i]=0;
		i++;
	}
	i=0;
	while(i<size)
	{
		if((used[i]==0)&&(!samedone[i]))
		{
			int j=i;
			entered=1;
			used[i]=1;
			pre[sofar]=letters[i];
			combinations(pre, sofar+1);
			used[i]=0;
			
			
			while(sameas[j]!=-1)
			{
				samedone[j]=1;
				j=sameas[j];
			}
			samedone[j]=1;
		}

		i++;
	}
	free(samedone);
	if(entered==0)
	{	
		count++;
		
		
		pre[sofar]='\0';
		{
			char** key = &pre;
			char* init=(char*)bsearch(key,dictionary, gi, 4,(int (*) (const void*, const void*)) comp);
			if(init!=NULL)
			{	
				
				strcpy(results[matches],pre);
				matches++;
			}
		}
	}	
}







LRESULT CALLBACK WndProc( HWND hWnd, UINT messg,
								WPARAM wParam, LPARAM lParam );


char szProgName[] = "Hello Win32"; /* name of application */
char message[] = "Hello from Win32"; /* message to be printed in client area */

								
int WINAPI WinMain( HINSTANCE hInst, 	/*Win32 entry-point routine */
					HINSTANCE hPreInst, 
					LPSTR lpszCmdLine, 
					int nCmdShow )
{
	
	HWND hWnd;
	MSG lpMsg;
	WNDCLASS wc;

	if( !hPreInst )			/*set up window class and register it */
	{
		wc.lpszClassName 	= szProgName;
		wc.hInstance 		= hInst;
		wc.lpfnWndProc		= WndProc;
		wc.hCursor			= LoadCursor( NULL, IDC_ARROW );
		wc.hIcon			= LoadIcon( NULL, IDI_APPLICATION );
		wc.lpszMenuName		= NULL;
		wc.hbrBackground	= (HBRUSH)GetStockObject( LTGRAY_BRUSH );
		wc.style			= 0;
		wc.cbClsExtra		= 0;
		wc.cbWndExtra		= 0;

		if( !RegisterClass( &wc ) )
			return FALSE;
	}


	hWnd = CreateWindow( 	szProgName,							/* now create the window */
							"CodeWarrior Win32 stationery",
							DS_MODALFRAME ,
							400,
							400,
							400,
							150,
							(HWND)NULL,
							(HMENU)NULL,
							(HINSTANCE)hInst,
							(LPSTR)NULL		);
	
	LPDIRECTDRAW lpdd= NULL;
	LPDIRECTDRAW7 lpdd4= NULL;
	DirectDrawCreate(NULL, &lpdd, NULL);

	lpdd->QueryInterface(IID_IDirectDraw7,(LPVOID*)&lpdd4);
	if(FAILED(lpdd4->SetCooperativeLevel(hWnd,DDSCL_NORMAL)))
			return 0;
	lpdd4->SetDisplayMode(640,480,8,0,0);
	ShowWindow(hWnd, nCmdShow );
	UpdateWindow( hWnd );
	


	while( GetMessage( &lpMsg, NULL, 0, 0 ) )					/* begin the message loop */
	{
		TranslateMessage( &lpMsg );
		DispatchMessage( &lpMsg );
	}
	
	int myI=0;
	while(myI<255)
	{
		free(results[myI]);
		myI++;
	}
	free(results);
	return( lpMsg.wParam);
}



LRESULT CALLBACK WndProc( HWND hWnd, UINT messg,				/*callback procedure */
								WPARAM wParam, LPARAM lParam )
{
	HDC hdc; 				/* handle to the device context */
	PAINTSTRUCT pstruct; 	/*struct for the call to BeginPaint */
	HINSTANCE hInstance;
	char buffer[255];
	switch(messg)
	{
		static HWND hCombo1,hCombo2,hCombo3,hCombo4;
		static HWND edit1, edit2, edit3, edit4;
		static HWND ok;
		case WM_COMMAND:
		{
			if(HIWORD(wParam)==BN_CLICKED)
			{
				if(LOWORD(wParam)==1)
				{
				
					int num_results=0;
					SendMessage (edit1, EM_GETLINE, 0,
                            (LPARAM) buffer);

                    SendMessage (hCombo1, CB_RESETCONTENT, 0, 0) ;
					num_results = getSolution((char*)buffer);
					
					if(num_results>0)
					{
						int i =0;
						//num_results=4;
						while(i<num_results)
							SendMessage(hCombo1, CB_ADDSTRING,0,(LPARAM)results[i++]);
					}
					SendMessage (hCombo1, CB_SETCURSEL, 0, 0) ;

					num_results=0;
					SendMessage (edit2, EM_GETLINE, 0,
                            (LPARAM) buffer);

                    SendMessage (hCombo2, CB_RESETCONTENT, 0, 0) ;
					num_results = getSolution((char*)buffer);
					
					if(num_results>0)
					{
						int i =0;
						//num_results=4;
						while(i<num_results)
							SendMessage(hCombo2, CB_ADDSTRING,0,(LPARAM)results[i++]);
					}
					SendMessage (hCombo2, CB_SETCURSEL, 0, 0) ;

					num_results=0;
					SendMessage (edit3, EM_GETLINE, 0,
                            (LPARAM) buffer);

                    SendMessage (hCombo3, CB_RESETCONTENT, 0, 0) ;
					num_results = getSolution((char*)buffer);
					
					if(num_results>0)
					{
						int i =0;
						//num_results=4;
						while(i<num_results)
							SendMessage(hCombo3, CB_ADDSTRING,0,(LPARAM)results[i++]);
					}
					SendMessage (hCombo3, CB_SETCURSEL, 0, 0) ;

					num_results=0;
					SendMessage (edit4, EM_GETLINE, 0,
                            (LPARAM) buffer);

                    SendMessage (hCombo4, CB_RESETCONTENT, 0, 0) ;
					num_results = getSolution((char*)buffer);
					
					if(num_results>0)
					{
						int i =0;
						//num_results=4;
						while(i<num_results)
							SendMessage(hCombo4, CB_ADDSTRING,0,(LPARAM)results[i++]);
					}
					SendMessage (hCombo4, CB_SETCURSEL, 0, 0) ;
				}
			}
		
		}
		break;
		
		case WM_CREATE:
		{
			int myI =0;
			results = (char**)malloc(255*4);
			while(myI<255)
			{
				results[myI] = (char*)malloc(255);
				myI++;
			}
			hInstance = (HINSTANCE)GetWindowLong (hWnd, GWL_HINSTANCE) ;
			ok = CreateWindow("BUTTON","Ok",
							WS_CHILD |WS_VISIBLE|WS_BORDER,
							160, 95, 40, 20, hWnd, (HMENU)1, hInstance, NULL); 
			edit1 = CreateWindow ("EDIT", "",
                    		WS_CHILD |WS_VISIBLE|WS_BORDER,
                    		10, 10, 180, 20, hWnd, (HMENU)1, hInstance, NULL); 
		    edit2 = CreateWindow ("EDIT", "",
		                    WS_CHILD |WS_VISIBLE|WS_BORDER,
		                    10, 30, 180, 20, hWnd, (HMENU)2, hInstance, NULL); 
		    edit3 = CreateWindow ("EDIT", "",
		                    WS_CHILD|WS_VISIBLE|WS_BORDER,
		                    10, 50, 180, 20, hWnd, (HMENU)3, hInstance, NULL); 
		    edit4 = CreateWindow ("EDIT", "",
		                    WS_CHILD|WS_VISIBLE|WS_BORDER,
		                    10, 70, 180, 20, hWnd, (HMENU)4, hInstance, NULL); 
			hCombo1 = CreateWindow ("COMBOBOX", "",
                    WS_CHILD | CBS_DROPDOWN | CBS_SORT | WS_VSCROLL,
                    		190, 10, 180, 120, hWnd, (HMENU)1, hInstance, NULL); 
		    hCombo2 = CreateWindow ("COMBOBOX", "",
		                    WS_CHILD | CBS_DROPDOWN | CBS_SORT | WS_VSCROLL,
		                    190, 30, 180, 120, hWnd, (HMENU)2, hInstance, NULL); 
		    hCombo3 = CreateWindow ("COMBOBOX", "",
		                    WS_CHILD | CBS_DROPDOWN | CBS_SORT | WS_VSCROLL,
		                    190, 50, 180, 120, hWnd, (HMENU)3, hInstance, NULL); 
		    hCombo4 = CreateWindow ("COMBOBOX", "",
		                    WS_CHILD | CBS_DROPDOWN | CBS_SORT | WS_VSCROLL,
		                    190, 70, 180, 120, hWnd, (HMENU)4, hInstance, NULL);
		             
			ShowWindow (hCombo1, SW_SHOWNORMAL);
			ShowWindow (hCombo2, SW_SHOWNORMAL);
			ShowWindow (hCombo3, SW_SHOWNORMAL);
			ShowWindow (hCombo4, SW_SHOWNORMAL);
			ShowWindow(edit1,SW_NORMAL);
			ShowWindow(edit2,SW_NORMAL);
			ShowWindow(edit3,SW_NORMAL);
			ShowWindow(edit4,SW_NORMAL);
		}
		break;
		
		case WM_PAINT:
		hdc = BeginPaint(hWnd, &pstruct ); /* prepare window for painting*/
		
		//TextOut( hdc, 0, 0, message, ( sizeof(message) - 1 ) ); /*print hello at upper left corner */
		
		EndPaint(hWnd, &pstruct );	/* stop painting */
		break;
		
		case WM_DESTROY:
	
			PostQuitMessage( 0 );
		break;
	
		default:
		return( DefWindowProc( hWnd, messg, wParam, lParam ) );
	}

	return( 0L );
}